
/*
    xskat - a card game for 1 to 3 players.
    Copyright (C) 1998  Gunter Gerhardt

    This program is free software; you can redistribute it freely.
    Use it at your own risk; there is NO WARRANTY.
*/

#ifndef XDIAL_H
#define XDIAL_H

#undef EXTERN
#ifdef XDIAL_C
#define EXTERN
#else
#define EXTERN extern
#endif

#define OB_NONE       0
#define OB_BUTTON     (1<<0)
#define OB_EXIT       (1<<1)
#define OB_SELECTED   (1<<2)
#define OB_CENTERED   (1<<3)
#define OB_HIDDEN     (1<<4)
#define OB_BOLD       (1<<5)
#define OB_UNDERLINED (1<<6)
#define OB_RIGHT      (1<<7)

#define TOB(t) ((char *)((t)+OB_NONE+1))

typedef struct {
  int spec;
  int x,y,w,h;
  char *str;
  int next;
  Window win;
} OBJECT;

EXTERN OBJECT *actdial[3];
EXTERN OBJECT *resdial[3];
EXTERN int ktrsag,ktrnext;

EXTERN OBJECT dihand[]
#ifdef XDIAL_C
=
{
  {4,0,0,19,6,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,17,1,TOB(TX_HAND_F),OB_NONE},
  {OB_EXIT,2,4,6,1,TOB(TX_JA),OB_NONE},
  {OB_EXIT,11,4,6,1,TOB(TX_NEIN),OB_NONE}
}
#endif
;

EXTERN OBJECT digrandhand[]
#ifdef XDIAL_C
=
{
  {4,0,0,19,6,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,17,1,TOB(TX_GRAND_HAND),OB_NONE},
  {OB_EXIT,2,4,6,1,TOB(TX_NEIN),OB_NONE},
  {OB_EXIT,11,4,6,1,TOB(TX_JA),OB_NONE}
}
#endif
;

EXTERN OBJECT dischieben[]
#ifdef XDIAL_C
=
{
  {4,0,0,23,6,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,21,1,TOB(TX_SKAT_AUFNEHMEN),OB_NONE},
  {OB_EXIT,4,4,6,1,TOB(TX_JA),OB_NONE},
  {OB_EXIT,13,4,6,1,TOB(TX_NEIN),OB_NONE}
}
#endif
;

EXTERN OBJECT diverdoppelt[]
#ifdef XDIAL_C
=
{
  {5,0,0,33,8,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,31,1,TOB(TX_VERDOPPELT),OB_NONE},
  {OB_CENTERED,1,3,31,1,OB_NONE,OB_NONE},
  {OB_CENTERED,1,4,31,1,TOB(TX_SCHIEBT),OB_NONE},
  {OB_EXIT,12,6,9,1,TOB(TX_AHA),OB_NONE}
}
#endif
;

EXTERN OBJECT dibuben[]
#ifdef XDIAL_C
=
{
  {4,0,0,43,7,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,41,1,TOB(TX_HINWEIS),OB_NONE},
  {OB_CENTERED,1,3,41,1,TOB(TX_BUBEN_NICHT),OB_NONE},
  {OB_EXIT,17,5,9,1,TOB(TX_AHA),OB_NONE}
}
#endif
;

EXTERN OBJECT diende[3][4]
#ifdef XDIAL_C
=
{{
  {4,0,0,19,6,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,17,1,TOB(TX_SPIEL_BEENDEN),OB_NONE},
  {OB_EXIT,2,4,6,1,TOB(TX_JA),OB_NONE},
  {OB_EXIT,11,4,6,1,TOB(TX_NEIN),OB_NONE}
}}
#endif
;

EXTERN OBJECT diterm[3][5]
#ifdef XDIAL_C
=
{{
  {5,0,0,23,8,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,21,1,TOB(TX_SPIELENDE),OB_NONE},
  {OB_CENTERED,2,3,19,1,OB_NONE,OB_NONE},
  {OB_CENTERED,2,4,19,1,TOB(TX_BEENDET_DAS_SPIEL),OB_NONE},
  {OB_EXIT,8,6,7,1,TOB(TX_AHA),OB_NONE}
}}
#endif
;

EXTERN OBJECT diloesch[]
#ifdef XDIAL_C
=
{
  {4,0,0,19,6,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,17,1,TOB(TX_LOESCHEN_F),OB_NONE},
  {OB_EXIT,2,4,6,1,TOB(TX_JA),OB_NONE},
  {OB_EXIT,11,4,6,1,TOB(TX_NEIN),OB_NONE}
}
#endif
;

EXTERN OBJECT dispiel[]
#ifdef XDIAL_C
=
{
  {13,0,0,43,13,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,41,1,TOB(TX_SPIEL),OB_NONE},
  {OB_BUTTON,2,3,9,1,TOB(TX_KARO),1},
  {OB_BUTTON,12,3,9,1,TOB(TX_HERZ),1},
  {OB_BUTTON,22,3,9,1,TOB(TX_PIK),1},
  {OB_BUTTON,32,3,9,1,TOB(TX_KREUZ),1},
  {OB_BUTTON,2,5,19,1,TOB(TX_NULL),1},
  {OB_BUTTON,22,5,19,1,TOB(TX_GRAND),-5},
  {OB_BUTTON,2,7,12,1,TOB(TX_SCHNEIDER),OB_NONE},
  {OB_BUTTON,15,7,13,1,TOB(TX_SCHWARZ),OB_NONE},
  {OB_BUTTON,29,7,12,1,TOB(TX_OUVERT),OB_NONE},
  {OB_EXIT,15,9,13,1,TOB(TX_ANSAGEN),OB_NONE},
  {OB_CENTERED,1,11,41,1,OB_NONE,OB_NONE}
}
#endif
;

EXTERN OBJECT difehler[]
#ifdef XDIAL_C
=
{
  {7,0,0,43,11,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,41,1,TOB(TX_HINWEIS),OB_NONE},
  {OB_CENTERED,1,3,41,1,TOB(TX_F1),OB_NONE},
  {OB_CENTERED,1,4,41,1,TOB(TX_F2),OB_NONE},
  {OB_CENTERED,1,6,41,1,TOB(TX_F3),OB_NONE},
  {OB_CENTERED,1,7,41,1,TOB(TX_F4),OB_NONE},
  {OB_EXIT,17,9,9,1,TOB(TX_AHA),OB_NONE}
}
#endif
;

EXTERN OBJECT diueberr[]
#ifdef XDIAL_C
=
{
  {7,0,0,43,11,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,41,1,TOB(TX_HINWEIS),OB_NONE},
  {OB_CENTERED,1,3,41,1,TOB(TX_U1),OB_NONE},
  {OB_CENTERED,1,4,41,1,TOB(TX_U2),OB_NONE},
  {OB_CENTERED,1,6,41,1,TOB(TX_U3),OB_NONE},
  {OB_CENTERED,1,7,41,1,TOB(TX_U4),OB_NONE},
  {OB_EXIT,17,9,9,1,TOB(TX_AHA),OB_NONE}
}
#endif
;

EXTERN OBJECT diansage[]
#ifdef XDIAL_C
=
{
  {3,0,0,17,6,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,15,1,TOB(TX_ANGESAGT_IST),OB_NONE},
  {OB_EXIT,3,4,11,1,OB_NONE,OB_NONE}
}
#endif
;

EXTERN OBJECT dikontra[]
#ifdef XDIAL_C
=
{
  {5,0,0,24,7,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,22,1,TOB(TX_ANGESAGT_IST),OB_NONE},
  {OB_CENTERED,1,3,22,1,OB_NONE,OB_NONE},
  {OB_EXIT,2,5,9,1,TOB(TX_KONTRA),OB_NONE},
  {OB_EXIT,13,5,9,1,TOB(TX_AHA),OB_NONE}
}
#endif
;

EXTERN OBJECT direkontra[]
#ifdef XDIAL_C
=
{
  {5,0,0,28,7,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,26,1,TOB(TX_KONTRA_T),OB_NONE},
  {OB_CENTERED,1,3,26,1,OB_NONE,OB_NONE},
  {OB_EXIT,4,5,9,1,TOB(TX_RE),OB_NONE},
  {OB_EXIT,15,5,9,1,TOB(TX_AHA),OB_NONE}
}
#endif
;

EXTERN OBJECT dikonre[]
#ifdef XDIAL_C
=
{
  {5,0,0,24,8,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,22,1,TOB(TX_ANGESAGT_IST),OB_NONE},
  {OB_CENTERED,1,3,22,1,OB_NONE,OB_NONE},
  {OB_CENTERED,1,4,22,1,OB_NONE,OB_NONE},
  {OB_EXIT,7,6,10,1,TOB(TX_AHA),OB_NONE}
}
#endif
;

EXTERN OBJECT diwieder[]
#ifdef XDIAL_C
=
{
  {11,0,0,37,10,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,35,1,TOB(TX_SPIEL_WIEDER),OB_NONE},
  {OB_CENTERED,1,3,35,1,TOB(TX_MIT_DEN_KARTEN),OB_NONE},
  {OB_CENTERED,2,5,9,1,TOB(TX_COMPUTER),OB_NONE},
  {OB_CENTERED,26,5,9,1,TOB(TX_COMPUTER),OB_NONE},
  {OB_EXIT,2,6,9,1,TOB(TX_LINKS),OB_NONE},
  {OB_EXIT,14,6,9,1,TOB(TX_MIR),OB_NONE},
  {OB_EXIT,26,6,9,1,TOB(TX_RECHTS),OB_NONE},
  {OB_NONE,2,8,18,1,TOB(TX_VORHAND_WECHSELT),OB_NONE},
  {OB_BUTTON,23,8,6,1,TOB(TX_JA),1},
  {OB_BUTTON,29,8,6,1,TOB(TX_NEIN),-1}
}
#endif
;

EXTERN OBJECT diresult[]
#ifdef XDIAL_C
=
{
  {20,0,0,37,17,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,35,1,TOB(TX_RESULTAT),OB_NONE},
  {OB_CENTERED|OB_BOLD,1,2,35,1,OB_NONE,OB_NONE},
  {OB_CENTERED,1,3,35,1,OB_NONE,OB_NONE},
  {OB_CENTERED,1,5,35,1,OB_NONE,OB_NONE},
  {OB_CENTERED,1,7,35,1,TOB(TX_DER_SPIELWERT_IST),OB_NONE},
  {OB_CENTERED,4,9,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,14,9,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,24,9,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,4,10,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,14,10,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,24,10,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,5,11,8,1,OB_NONE,OB_NONE},
  {OB_CENTERED,15,11,8,1,OB_NONE,OB_NONE},
  {OB_CENTERED,25,11,8,1,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_BOLD,1,12,35,1,OB_NONE,OB_NONE},
  {OB_EXIT,3,13,14,1,TOB(TX_ENDE),OB_NONE},
  {OB_EXIT,20,13,14,1,TOB(TX_WIEDER),OB_NONE},
  {OB_EXIT,3,15,14,1,TOB(TX_PROTOKOLL),OB_NONE},
  {OB_EXIT,20,15,14,1,TOB(TX_WEITER),OB_NONE}
}
#endif
;

EXTERN OBJECT dismlres[3][15]
#ifdef XDIAL_C
=
{{
  {15,0,0,33,8,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_BOLD,1,0,31,1,OB_NONE,OB_NONE},
  {OB_CENTERED,1,1,31,1,OB_NONE,OB_NONE},
  {OB_CENTERED,1,2,31,1,OB_NONE,OB_NONE},
  {OB_CENTERED,1,3,31,1,TOB(TX_DER_SPIELWERT_IST),OB_NONE},
  {OB_CENTERED,2,4,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,12,4,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,22,4,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,2,5,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,12,5,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,22,5,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,3,6,8,1,OB_NONE,OB_NONE},
  {OB_CENTERED,13,6,8,1,OB_NONE,OB_NONE},
  {OB_CENTERED,23,6,8,1,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_BOLD,1,7,31,1,OB_NONE,OB_NONE}
}}
#endif
;

EXTERN OBJECT diproto[3][50]
#ifdef XDIAL_C
=
{{
  {50,0,0,40,23,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,38,1,TOB(TX_PROTOKOLL_T),OB_NONE},
  {OB_CENTERED,2,3,12,1,OB_NONE,OB_NONE},
  {OB_CENTERED,14,3,12,1,OB_NONE,OB_NONE},
  {OB_CENTERED,26,3,12,1,OB_NONE,OB_NONE},
  {OB_CENTERED,2,4,12,1,OB_NONE,OB_NONE},
  {OB_CENTERED,14,4,12,1,OB_NONE,OB_NONE},
  {OB_CENTERED,26,4,12,1,OB_NONE,OB_NONE},
  {OB_NONE,4,5,11,1,OB_NONE,OB_NONE},
  {OB_NONE,16,5,11,1,OB_NONE,OB_NONE},
  {OB_NONE,28,5,11,1,OB_NONE,OB_NONE},
  {OB_NONE,4,6,11,1,OB_NONE,OB_NONE},
  {OB_NONE,16,6,11,1,OB_NONE,OB_NONE},
  {OB_NONE,28,6,11,1,OB_NONE,OB_NONE},
  {OB_NONE,4,7,11,1,OB_NONE,OB_NONE},
  {OB_NONE,16,7,11,1,OB_NONE,OB_NONE},
  {OB_NONE,28,7,11,1,OB_NONE,OB_NONE},
  {OB_NONE,4,8,11,1,OB_NONE,OB_NONE},
  {OB_NONE,16,8,11,1,OB_NONE,OB_NONE},
  {OB_NONE,28,8,11,1,OB_NONE,OB_NONE},
  {OB_NONE,4,9,11,1,OB_NONE,OB_NONE},
  {OB_NONE,16,9,11,1,OB_NONE,OB_NONE},
  {OB_NONE,28,9,11,1,OB_NONE,OB_NONE},
  {OB_NONE,4,10,11,1,OB_NONE,OB_NONE},
  {OB_NONE,16,10,11,1,OB_NONE,OB_NONE},
  {OB_NONE,28,10,11,1,OB_NONE,OB_NONE},
  {OB_NONE,4,11,11,1,OB_NONE,OB_NONE},
  {OB_NONE,16,11,11,1,OB_NONE,OB_NONE},
  {OB_NONE,28,11,11,1,OB_NONE,OB_NONE},
  {OB_NONE,4,12,11,1,OB_NONE,OB_NONE},
  {OB_NONE,16,12,11,1,OB_NONE,OB_NONE},
  {OB_NONE,28,12,11,1,OB_NONE,OB_NONE},
  {OB_NONE,4,13,11,1,OB_NONE,OB_NONE},
  {OB_NONE,16,13,11,1,OB_NONE,OB_NONE},
  {OB_NONE,28,13,11,1,OB_NONE,OB_NONE},
  {OB_NONE,4,14,11,1,OB_NONE,OB_NONE},
  {OB_NONE,16,14,11,1,OB_NONE,OB_NONE},
  {OB_NONE,28,14,11,1,OB_NONE,OB_NONE},
  {OB_NONE,2,15,13,1,OB_NONE,OB_NONE},
  {OB_NONE,16,15,22,1,OB_NONE,OB_NONE},
  {OB_NONE,2,16,37,1,OB_NONE,OB_NONE},
  {OB_NONE,16,16,22,1,OB_NONE,OB_NONE},
  {OB_NONE,2,17,13,1,OB_NONE,OB_NONE},
  {OB_NONE,16,17,22,1,OB_NONE,OB_NONE},
  {OB_NONE,2,18,37,1,OB_NONE,OB_NONE},
  {OB_NONE,2,19,13,1,OB_NONE,OB_NONE},
  {OB_NONE,16,19,23,1,OB_NONE,OB_NONE},
  {OB_EXIT,2,21,12,1,TOB(TX_SPIELLISTE),OB_NONE},
  {OB_EXIT,17,21,12,1,TOB(TX_WEITER),OB_NONE},
  {OB_EXIT,32,21,6,1,OB_NONE,OB_NONE}
}}
#endif
;

EXTERN OBJECT diliste[3][62]
#ifdef XDIAL_C
=
{{
  {62,0,0,38,21,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,36,1,TOB(TX_SPIELLISTE_T),OB_NONE},
  {OB_CENTERED,2,3,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,12,3,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,22,3,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,2,4,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,12,4,10,1,OB_NONE,OB_NONE},
  {OB_CENTERED,22,4,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,5,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,5,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,5,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,6,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,6,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,6,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,6,7,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,7,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,7,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,7,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,7,7,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,8,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,8,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,8,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,8,7,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,9,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,9,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,9,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,9,7,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,10,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,10,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,10,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,10,7,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,11,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,11,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,11,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,11,7,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,12,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,12,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,12,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,12,7,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,13,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,13,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,13,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,13,7,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,14,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,14,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,14,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,14,7,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,15,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,15,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,15,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,15,7,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,16,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,16,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,16,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,16,7,1,OB_NONE,OB_NONE},
  {OB_RIGHT,1,17,8,1,OB_NONE,OB_NONE},
  {OB_RIGHT,9,17,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,19,17,10,1,OB_NONE,OB_NONE},
  {OB_RIGHT,29,17,7,1,OB_NONE,OB_NONE},
  {OB_EXIT,2,19,8,1,OB_NONE,OB_NONE},
  {OB_EXIT,13,19,12,1,TOB(TX_WEITER),OB_NONE},
  {OB_EXIT,28,19,8,1,OB_NONE,OB_NONE}
}}
#endif
;

EXTERN OBJECT dioptions[3][22]
#ifdef XDIAL_C
=
{{
  {22,0,0,38,21,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,36,1,TOB(TX_XSKAT),OB_NONE},
  {OB_EXIT,2,3,34,1,TOB(TX_COPYRIGHT),OB_NONE},
  {OB_NONE,2,5,35,1,TOB(TX_SORTIEREN),OB_NONE},
  {OB_BUTTON,5,6,13,1,TOB(TX_AUFWAERTS),1},
  {OB_BUTTON,20,6,13,1,TOB(TX_ABWAERTS),-1},
  {OB_BUTTON,5,7,13,1,TOB(TX_ALTERNIEREND),1},
  {OB_BUTTON,20,7,13,1,TOB(TX_SEQUENTIELL),-1},
  {OB_BUTTON,5,8,13,1,TOB(TX_NULL),1},
  {OB_BUTTON,20,8,13,1,TOB(TX_NORMAL),-1},
  {OB_NONE,2,9,35,1,OB_NONE,OB_NONE},
  {OB_NONE,2,10,35,1,TOB(TX_GEREIZT_BIS_L),OB_NONE},
  {OB_NONE,2,11,35,1,TOB(TX_GESPIELT_WIRD),OB_NONE},
  {OB_NONE,2,12,35,1,TOB(TX_LETZTER_STICH),OB_NONE},
  {OB_NONE,2,12,35,1,TOB(TX_GEDRUECKT),OB_NONE},
  {OB_NONE,5,13,32,1,OB_NONE,OB_NONE},
  {OB_NONE,5,14,32,1,OB_NONE,OB_NONE},
  {OB_NONE,5,15,32,1,OB_NONE,OB_NONE},
  {OB_EXIT,5,17,13,1,TOB(TX_SPIELLISTE),OB_NONE},
  {OB_EXIT,20,17,13,1,TOB(TX_OPTIONEN),OB_NONE},
  {OB_EXIT,5,19,13,1,TOB(TX_ENDE),OB_NONE},
  {OB_EXIT,20,19,13,1,TOB(TX_WEITER),OB_NONE}
}}
#endif
;

EXTERN OBJECT dicopyr[3][11]
#ifdef XDIAL_C
=
{{
  {11,0,0,40,16,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,38,1,TOB(TX_XSKAT),OB_NONE},
  {OB_CENTERED,1,3,38,1,TOB(TX_COPYRIGHT),OB_NONE},
  {OB_CENTERED,1,4,38,1,TOB(TX_EMAIL),OB_NONE},
  {OB_CENTERED,1,6,38,1,TOB(TX_HOMEPAGE),OB_NONE},
  {OB_CENTERED,1,7,38,1,TOB(TX_URL),OB_NONE},
  {OB_CENTERED,1,9,38,1,TOB(TX_FR1),OB_NONE},
  {OB_CENTERED,1,10,38,1,TOB(TX_FR2),OB_NONE},
  {OB_CENTERED,1,11,38,1,TOB(TX_FR3),OB_NONE},
  {OB_CENTERED,1,12,38,1,TOB(TX_FR4),OB_NONE},
  {OB_EXIT,13,14,14,1,TOB(TX_WEITER),OB_NONE}
}}
#endif
;

EXTERN OBJECT distrateg[3][25]
#ifdef XDIAL_C
=
{{
  {25,0,0,38,9,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,36,1,TOB(TX_STRATEGIE),OB_NONE},
  {OB_NONE,10,3,10,1,TOB(TX_PASSE_K),OB_NONE},
  {OB_RIGHT,27,3,10,1,TOB(TX_SAGE18),OB_NONE},
  {OB_NONE,1,4,9,1,TOB(TX_LINKS),OB_NONE},
  {OB_BUTTON,10,4,3,1,OB_NONE,1},
  {OB_BUTTON,13,4,3,1,OB_NONE,1},
  {OB_BUTTON,16,4,3,1,OB_NONE,1},
  {OB_BUTTON,19,4,3,1,OB_NONE,1},
  {OB_BUTTON,22,4,3,1,OB_NONE,1},
  {OB_BUTTON,25,4,3,1,OB_NONE,1},
  {OB_BUTTON,28,4,3,1,OB_NONE,1},
  {OB_BUTTON,31,4,3,1,OB_NONE,1},
  {OB_BUTTON,34,4,3,1,OB_NONE,-8},
  {OB_NONE,1,5,9,1,TOB(TX_RECHTS),OB_NONE},
  {OB_BUTTON,10,5,3,1,OB_NONE,1},
  {OB_BUTTON,13,5,3,1,OB_NONE,1},
  {OB_BUTTON,16,5,3,1,OB_NONE,1},
  {OB_BUTTON,19,5,3,1,OB_NONE,1},
  {OB_BUTTON,22,5,3,1,OB_NONE,1},
  {OB_BUTTON,25,5,3,1,OB_NONE,1},
  {OB_BUTTON,28,5,3,1,OB_NONE,1},
  {OB_BUTTON,31,5,3,1,OB_NONE,1},
  {OB_BUTTON,34,5,3,1,OB_NONE,-8},
  {OB_EXIT,12,7,14,1,TOB(TX_WEITER),OB_NONE}
}}
#endif
;

EXTERN OBJECT divarianten[3][21]
#ifdef XDIAL_C
=
{{
  {21,0,0,42,11,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,40,1,TOB(TX_VARIANTEN),OB_NONE},
  {OB_NONE,1,3,20,1,TOB(TX_RAMSCH_SPIELEN),OB_NONE},
  {OB_BUTTON,17,3,7,1,TOB(TX_NEIN),1},
  {OB_BUTTON,24,3,7,1,TOB(TX_JA),1},
  {OB_BUTTON,31,3,10,1,TOB(TX_IMMER),-2},
  {OB_NONE,1,4,20,1,TOB(TX_SCHIEBERAMSCH),OB_NONE},
  {OB_BUTTON,17,4,7,1,TOB(TX_NEIN),1},
  {OB_BUTTON,24,4,7,1,TOB(TX_JA),-1},
  {OB_NONE,1,5,20,1,TOB(TX_KONTRA_SAGEN),OB_NONE},
  {OB_BUTTON,17,5,7,1,TOB(TX_NEIN),1},
  {OB_BUTTON,24,5,7,1,TOB(TX_JA),1},
  {OB_BUTTON,31,5,10,1,TOB(TX_AB18),-2},
  {OB_NONE,1,6,20,1,TOB(TX_BOCK_RUNDEN),OB_NONE},
  {OB_BUTTON,17,6,7,1,TOB(TX_NEIN),1},
  {OB_BUTTON,24,6,7,1,TOB(TX_JA),1},
  {OB_BUTTON,31,6,10,1,TOB(TX_UND_RAMSCH),-2},
  {OB_NONE,3,7,18,1,TOB(TX_FORTSETZEN),OB_NONE},
  {OB_BUTTON,17,7,7,1,TOB(TX_NEIN),1},
  {OB_BUTTON,24,7,7,1,TOB(TX_JA),-1},
  {OB_EXIT,14,9,14,1,TOB(TX_WEITER),OB_NONE}
}}
#endif
;

EXTERN OBJECT dibockevents[3][11]
#ifdef XDIAL_C
=
{{
  {11,0,0,42,14,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,40,1,TOB(TX_BOCK_EREIGNISSE_T),OB_NONE},
  {OB_BUTTON,2,3,38,1,TOB(TX_VERLOREN_MIT_60),OB_NONE},
  {OB_BUTTON,2,4,38,1,TOB(TX_GRAND_HAND_GEWONNEN),OB_NONE},
  {OB_BUTTON,2,5,38,1,TOB(TX_ERFOLGREICHER_KONTRA),OB_NONE},
  {OB_BUTTON,2,6,38,1,TOB(TX_KONTRA_RE_ANGESAGT),OB_NONE},
  {OB_BUTTON,2,7,38,1,TOB(TX_NNN_IN_SPIELLISTE),OB_NONE},
  {OB_BUTTON,2,8,38,1,TOB(TX_N00_IN_SPIELLISTE),OB_NONE},
  {OB_BUTTON,2,9,38,1,TOB(TX_SPIELWERT_72),OB_NONE},
  {OB_BUTTON,2,10,38,1,TOB(TX_SPIELWERT_96),OB_NONE},
  {OB_EXIT,14,12,14,1,TOB(TX_WEITER),OB_NONE}
}}
#endif
;

EXTERN OBJECT diverzoegerung[3][11]
#ifdef XDIAL_C
=
{{
  {11,0,0,38,8,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,36,1,TOB(TX_VERZOEGERUNG),OB_NONE},
  {OB_CENTERED,1,3,36,1,TOB(TX_NIMM_STICH_NACH),OB_NONE},
  {OB_CENTERED,1,4,36,1,OB_NONE,OB_NONE},
  {OB_EXIT,2,6,3,1,OB_NONE,OB_NONE},
  {OB_EXIT,6,6,3,1,OB_NONE,OB_NONE},
  {OB_EXIT,10,6,3,1,OB_NONE,OB_NONE},
  {OB_EXIT,14,6,10,1,TOB(TX_WEITER),OB_NONE},
  {OB_EXIT,25,6,3,1,OB_NONE,OB_NONE},
  {OB_EXIT,29,6,3,1,OB_NONE,OB_NONE},
  {OB_EXIT,33,6,3,1,OB_NONE,OB_NONE}
}}
#endif
;

EXTERN OBJECT dimenubutton[3][9]
#ifdef XDIAL_C
=
{{
  {9,0,0,38,7,OB_NONE,OB_NONE},
  {OB_CENTERED|OB_UNDERLINED,1,1,36,1,TOB(TX_MENU_BUTTON),OB_NONE},
  {OB_BUTTON,3,3,7,1,TOB(TX_JEDER),1},
  {OB_BUTTON,11,3,4,1,OB_NONE,1},
  {OB_BUTTON,16,3,4,1,OB_NONE,1},
  {OB_BUTTON,21,3,4,1,OB_NONE,1},
  {OB_BUTTON,26,3,4,1,OB_NONE,1},
  {OB_BUTTON,31,3,4,1,OB_NONE,-5},
  {OB_EXIT,14,5,10,1,TOB(TX_WEITER),OB_NONE}
}}
#endif
;

#endif /* XDIAL_H */
